;;;-*-Mode: LISP; Package: CCL -*-

;;	Change History (most recent first):
;;  16 7/7/95  akh  one fred module
;;  (do not edit before this line!!)


; build-application.lisp
; Custom (non-LDS) application builder. Part of the Redistribution Kit.

; Copyright 1985-1988 Coral Software Corp.
; Copyright 1989-1994 Apple Computer, Inc.
; Copyright 1995 Digitool, Inc. The 'tool rules!

(in-package :ccl)

#| TO DO 7/5/96:
- check for & warn about:
  - multiple fasls in search path
  - out-of-date fasl found
|#

#-ppc-target                            ; not in 3.0
(defmethod application-init-file ((app application)) nil)
#-ppc-target                            ; not in 3.0
(defmethod application-init-file ((app lisp-development-system))
  "init")


;; Modification History
;
;  7/31/96 slh   appgen files are checked in now, restore us
;  6/26/96 gb    conditionalize out until missing file appears.
;  ------- 3.9
;  5/03/96 slh   updated from 3.0; init-file arg for build-application
;  2/29/96 slh   reset *module-file-alist* before find-module-pathnames calls
;  8/21/95 slh   verify-application-params: pass arg to a bwarn call
;  8/01/95 slh   generate-application: don't compile string-specified modules
;  7/25/95 slh   build/generate-application: look for home's MCL-AppGen first
;  7/20/95 slh   env-aux-control: CFD, or value dialog if option-key-p
;---------------- beta 1 release
;  7/13/95 slh   show sizes in module list; don't show packages; show custom categ msg
;  7/11/95 slh   generate-application: new compile-modules arg
;  7/06/95 slh   env-file-path, env-revert check for file
;  7/05/95 slh   :module-not-compiled warning; verify-module-params has its own
;                find-module-pathname which avoids lisp files on *module-file-alist*
;                verify-application-params: check toplevel fn, error-mode
;  6/29/95 slh   new build warnings mechanism; generate-application
;  6/28/95 slh   smarter dump-app-info
;  6/27/95 slh   moved some stuff to save-app-dlg module
;  6/26/95 slh   order module lists; launch-application: dialog not error
;                methods button
;  6/25/95 slh   added application-menubar, verify-menubar; set *mcl-menubar*
;                when dialog opened
;  6/23/95 slh   lotsa changes for MCL-AppGen
;  4/28/95 slh   don't save *module-file-alist* - it's paths to lisp files
;  4/11/95 slh   split off from save-application-dialog


(eval-when (:execute :compile-toplevel :load-toplevel)
  (require 'save-application-dialog))   ; load first

(%include "ccl:lib;appgen-misc.lisp")


;;; Redefinitions from MCL 3.0r1

(defvar *application-info* (make-app-info))

(let ((*warn-if-redefine* nil)
      (*warn-if-redefine-kernel* nil))
  
  ; *app-name* stays around for backward compatibility
  (defun set-app-name (name &optional (app-info *application-info*))
    (setf (app-info-name app-info) name
          *app-name* name))

  ; Redefined from ccl-menus-lds.lisp to show size, not print package qualifier.
  (defun print-env-var (spec &optional (stream t))
    (let ((*print-case* :downcase)
          (symbol  (first spec))
          (enabled (second spec))
          (info    (cddddr spec)))
      (unless (and (consp info)
                   (numberp (setq info (car info))))
        (setq info nil))
      ; if info (size) is set, then font is Monaco, else Geneva
      ; (10 pt. dot = 2 spaces, altcheckmark = 3 spaces)
      (format stream "~A ~:[~;:~]~A~@[~25T~4,' DK~]"
              (if enabled "  " (if info "   " "    "))
              (keywordp symbol)
              symbol
              info)))
  
  ; Redefined from ccl-menus-lds.lisp to deal with a list val-type, and no v-bool item.
  ; Also calls env-double-click-hack.
  (defun update-env-table (item &optional no-click)
    (let ((c (first-selected-cell item)))
      (when (and c
                 (or no-click
                     (not (env-double-click-hack (view-container item)))))
        (flet ((move-item (item &optional (pos #@(-1000 -1000)))
                 (when item
                   (set-view-position item pos))))
          (let* ((it (cell-contents item c))
                 (container (view-window item))
                 (v-bool    (view-named 'value container))
                 (v-typein  (view-named 'typein-value container))
                 (v-other   (view-named 'other container))
                 (val-type  (cddddr it)))
            (cond ((eq val-type :off))
                  ((or (functionp val-type)
                       (eq val-type t))  ; itsa typein
                   (when v-other (set-view-container v-other nil)) 
                   (move-item v-bool)
                   (set-dialog-item-text v-typein (format nil "~D" (cadr it)))
                   (move-item v-typein (add-points *env-value-position* #@(2 2))))
                  ((listp val-type) ; itsa boolean
                   (when v-other (set-view-container v-other nil))
                   (move-item v-typein)
                   (when (and v-bool (not (eql (view-position v-bool) *env-value-position*)))
                     (set-view-position v-bool *env-value-position*))
                   (let ((value (second it)))
                     (when (and (not no-click)
                                (double-click-p))
                       (setq value (setf (second it) (not value)))
                       (redraw-cell item c))
                     (when v-bool
                       (set-pop-up-menu-default-item v-bool (if value 1 2)))))
                  (t (move-item v-bool)
                     (move-item v-typein)
                     (move-item val-type *env-value-position*)
                     (when (and v-other (neq v-other val-type))
                       (set-view-container v-other nil))
                     (unless (eq (view-container val-type) container)
                       (set-view-container val-type container))
                     ; well thats real general huh!
                     (set-pop-up-menu-default-item 
                      val-type
                      (1+ (position  (symbol-name (cadr it)) 
                                     (menu-items val-type)
                                     :test
                                     #'(lambda (a b)
                                         (let ((title (menu-item-title b)))
                                           (string-equal a title
                                                         :start2 (if (eq (char title 0) #\:)
                                                                   1 0)))))))))
            (unless (eql it (table-last-cell item))
              (setf (table-last-cell item) it)
              (let ((output (fred-item (view-named 'documentation container))))
                (set-dialog-item-text output "")
                (view-put output :right-margin (- (point-h (view-size output)) 10))
                (env-show-doc container it output))))))))
  
  (defmethod env-double-click-hack ((dialog env-dialog))
    nil)
  
  
  ; redefined from dialogs.lisp to take :window-type keyword
  (defun y-or-n-dialog (message &key
                                (size yorn-dlg-size)
                                (position (list :top (+ 2 *menubar-bottom*)))
                                (yes-text "Yes")
                                (no-text "No")
                                (cancel-text "Cancel")
                                help-spec
                                (window-type :double-edge-box))
    (modal-dialog
     (make-instance 'keystroke-action-dialog
       :window-type window-type
       :view-size size
       :view-position position
       :window-show nil
       :help-spec (getf help-spec :dialog)
       :view-subviews
       `(
         ,(make-dialog-item 'static-text-dialog-item
                            #@(20 12) (subtract-points size #@(38 72))
                            message nil :help-spec (getf help-spec :dialog))
         ,(make-dialog-item 'default-button-dialog-item               
                            (subtract-points size #@(102 27))
                            #@(74 18) yes-text
                            #'(lambda (item) 
                                (declare (ignore item))
                                (return-from-modal-dialog t))
                            :help-spec (getf help-spec :yes-text))
         ,(make-dialog-item 'button-dialog-item
                            (if no-text (subtract-points size #@(102 53)) #@(5000 5000))
                            #@(74 18) no-text
                            #'(lambda (item)
                                (declare (ignore item))
                                (return-from-modal-dialog nil))
                            :help-spec (getf help-spec :no-text))
         ,(make-dialog-item 'button-dialog-item
                            (if cancel-text
                              ;(subtract-points size #@(102 77))
                              (make-point 25 (- (point-v size) 27))
                              #@(5000 5000))          ;off screen
                            #@(74 18) (or cancel-text "")
                            #'(lambda (item)
                                (declare (ignore item)) 
                                (return-from-modal-dialog :cancel))
                            :help-spec (getf help-spec :cancel-text))))))
  )

;;; Modules Dialog

(eval-when (:execute :compile-toplevel)
  (let ((*warn-if-redefine* nil)
        (*warn-if-redefine-kernel* nil))
    (require "APPGEN-DEFS")
    (require "DEFSTRUCT-MACROS")))

(pushnew (cons-pathname `(:absolute ,*appgen-folder*) nil nil "ccl")
         *module-search-path*
         :test #'equalp)

(declaim (special *app-class-name* *app-params-inited*))

(defvar *app-params-path* nil)

(defvar *app-verified* 0)               ; a count after verification run
(defvar *build-warnings-mode* nil)      ; nil, a window, or a list

(defvar *autolaunch-mcl-appgen* t)      ; launch MCL-AppGen from Save Application dialog

(defvar *module-categories* nil)        ; like *env-categories*
  
(defconstant custom-categ-name "Custom Modules")
(defconstant excl-categ-name "Excluded Modules")

; Define elements in reverse of order they should appear in;
;  categories must be in this order - env-show-doc may rely on this.
; The cddddr of a spec can be a list of used-by modules, and/or an optional
;  size value as the first of the list.
; NOTE: keep *optional-modules* up-to-date with this list!!
(unless *module-categories*
  (add-preference-vars
   '*module-categories*
   `((,custom-categ-name)                 ; must be first
     ("Optional Modules"
      (windoids nil t "functions for floating windows"
                . (6))
      (simple-db nil t "database functions for traps & help files"
                 . (5))
      (pprint nil t "the pretty-printer; if not used, PPRINT acts similar to PRINT"
              . (30))
      #|
      (fred-misc nil t "various optional functions and key-bindings for Fred"
                 . (14))
      (fred-additions nil t "various optional functions and key-bindings for Fred"
                      . (13))
      |#
      (fred nil t "Fred the editor" . (99 arglist simple-db))
      (eval nil t "the evaluator"
            . (36))
      (edhardcopy nil t "functions for printing Fred windows"
                  . (5))
      (compiler nil nil "the MCL compiler. Including the MCL compiler requires executing a MCL Compiler Object Code Distribution Agreement with Digitool, Inc."
                . (152))
      (boyer-moore nil t "the Search Files dialog and mechanism"
                   . (4))
      (arglist nil t "functions for recording and retrieving information about function argument lists"
               . (4))
      )
     ("Compile-time Modules"
      (print-db nil t "the print-db macro" . (1))
      (backquote nil t "the backquote reader/expander" . (2))
      )
     ("Keywords"
      (:unintern-macros nil nil
                        "Uninterns all symbols that were only bound to macros; :unbind-macros must be checked" . (52))
      (:unbind-macros nil nil
                      "Removes all macros" . (46))
      (:unintern-constants nil nil
                           "Uninterns all symbols that were only bound to constants; :unbind-constants must be checked" . (7))
      (:unbind-constants nil nil
                         "Removes all constants" . (1))
      )
     (,excl-categ-name
      (step-window nil nil "stepper window and inspector code" . :off)
      (step nil nil "the STEP macro and related code" . :off)
      (nfcomp nil nil "the file compiler" . :off)
      (inspector nil nil "the inspector" . :off)
      (encapsulate nil nil "support for TRACE, STEP, and ADVISE" . :off)
      (edit-callers nil nil "the Edit Callers dialog and related code" . :off)
      (doc-window nil nil "the documentation window and documentation accessors" . :off)
      (disassemble nil nil "low-level disassembler support" . :off)
      (disasm nil nil "high-level disassembler functions" . :off)
      (defstruct-lds nil nil "the DEFSTRUCT macro and compile-time support. LDS stands for Lisp Development System" . :off)
      (ccl-menus-lds nil nil "many of the dialogs for the Tools menu. LDS stands for Lisp Development System" . :off)
      (backtrace-lds nil nil "support for the Backtrace dialog. LDS stands for Lisp Development System" . :off)
      (apropos-dialog nil nil "the APROPOS function and related code" . :off)
      (apropos nil nil "the Apropos dialog" . :off)
      )
     )))

#| yuk, just be careful
(eval-when (:execute :compile-toplevel)
  (when (and (boundp '*module-categories*)
             *module-categories*
             (set-difference *optional-modules*
                             (mapcar #'car (cdr (assoc "Optional Modules" *module-categories*
                                                       :test #'string=)))))
    (cerror "Ignore error" "*optional-modules* and *module-categories* are out of synch")))
|#

(defclass modules-dialog (env-dialog) ())

(defmethod env-show-doc ((dialog modules-dialog) info where)
  (let ((categ-index (pop-up-menu-default-item (view-named 'category dialog)))
        (module (first info))
        (description (fourth info))
        type-val size)
    (set-dialog-item-text
     where
     (cond ((= 1 categ-index)
            (format nil "Custom module ~S." module))
           ((keywordp module)
            (format nil "~A." description))
           ((eq (setq type-val (cddddr info)) :off)
            (format nil "Contains ~A.~%~%This module cannot be included in an application."
                    description))
           ((not type-val)
            (format nil "Contains ~A." description))
           ((numberp (setq size (first type-val)))
            (format nil "Contains ~A; approximately ~DK.~@[~%Used by:~{ ~A~}~]"
                    description size (cdr type-val)))
           (t (format nil "Contains ~A.~@[~%Used by:~{ ~A~}~]"
                      description type-val)))))
  (force-output where))

(defmethod reset-env-table-sequence ((dialog modules-dialog) table categ &optional force)
  (set-dialog-item-enabled-p
   (view-named 'aux-control dialog)
   (string/= (car categ) excl-categ-name))
  (maybe-show-custom-msg dialog categ)
  (call-next-method dialog table categ force))

(defmethod maybe-show-custom-msg ((dialog modules-dialog) categ)
  (let ((categ-name (car categ)))
    (when (and (string= categ-name custom-categ-name)
               (null (cdr categ)))
      (let ((doc-item (fred-item (view-named 'documentation dialog))))
        (set-dialog-item-text
         doc-item
         "These are the custom modules returned by the APPLICATION-CUSTOM-MODULES method defined for the application.")
        (force-output doc-item)))))

(defmethod env-init-action ((dialog modules-dialog))
  (set-view-font *env-table* '("Monaco" 9))
  (maybe-show-custom-msg dialog (car *module-categories*)))

; (State: methods or globals -> categories)
(defmethod update-categories ((dialog modules-dialog) from-key)
  (case from-key
    (:initialize                        ; get state from methods
     (update-build-params))
    (:revert                            ; get state from globals
     (let* ((custom-categ t)
            (app-info *application-info*)
            (custom-modules   (app-info-custom-modules   app-info))
            (optional-modules (app-info-optional-modules app-info)))
       (dolist (categ *module-categories*)
         (dolist (spec (cdr categ))
           (let ((token (first spec)))
             (setf (second spec)
                   (find token (if custom-categ custom-modules optional-modules)
                         :test #'equalp))))
         (setq custom-categ nil))))))

; (State: methods -> categories and some globals)
(defun update-build-params ()
  (flet ((find-spec (module categ)
           (find module (cdr categ) :test #'equalp :key #'car))
         (reset-category (categ)
           (dolist (spec (cdr categ))
             (setf (second spec) nil))))
    (declare (dynamic-extent categ-find reset-category))
    (let* ((class-proto (class-prototype (find-class *app-class-name*)))
           (app-modules (application-custom-modules   class-proto))
           (opt-modules (application-optional-modules class-proto))
           (categs *module-categories*)
           (custom-categ   (first  categs))
           (optional-categ (second categs))
           (compiler-categ (third  categs))
           (keyword-categ  (fourth categs))
           (app-info *application-info*))
      (set-app-name (or (application-name class-proto) *app-name*) app-info)
      (setf (app-info-class-name app-info) *app-class-name*
            (cdr custom-categ) (mapcar #'(lambda (module)
                                           (list module t t))
                                       app-modules))
      (reset-category optional-categ)
      (reset-category compiler-categ)
      (reset-category keyword-categ)
      (dolist (module opt-modules)
        (let ((spec
               (cond ((keywordp module)
                      (or (find-spec module keyword-categ)
                          (progn (warn "Build keyword ~S is not one of ~S."
                                       module (mapcar #'car (cdr keyword-categ)))
                                 nil)))
                     ((symbolp module)
                      (or (find-spec module optional-categ)
                          (find-spec module compiler-categ)
                          (progn (warn "Unknown optional module specifier ~S." module)
                                 nil)))
                     (t (warn "Bad optional module specifier ~S (not SYMBOL or STRING)." module)
                        nil))))
          (when spec
            (setf (second spec) t))))))
  (setq *app-params-inited* t))

#| No, always enabled so you can revert to state when dialog opened.
(defmethod update-buttons ((dialog modules-dialog))
  (set-dialog-item-enabled-p (find-dialog-item dialog "Revert")
                             (and *app-params-path*
                                  (probe-file *app-params-path*))))
|#

(defmethod env-file-path ((dialog modules-dialog))
  (let ((path (app-params-path)))
    (values path (if path (probe-file path)))))

(defmethod env-aux-control ((dialog modules-dialog) categs)
  (catch :cancel
    (flet ((modulify (string)
             (intern (string-upcase string))))
      (declare (dynamic-extent #'modulify))
      (let ((custom-categ (first categs))
            (module (cond ((option-key-p)
                           (let ((string (get-string-from-user "Module name or path:")))
                             (if (find-if #'(lambda (char)
                                              (memq char '(#\: #\; #\.)))          ; implies pathname
                                          string)
                               string
                               (modulify string))))
                          (t (let ((path (choose-file-dialog :directory "home:"
                                                             :mac-file-type "FASL"
                                                             :mac-file-creator *ccl-file-creator*
                                                             :button-string "Select")))
                               (pushnew (make-pathname :directory (pathname-directory path))
                                        *module-search-path*
                                        :test #'equalp)
                               (modulify (pathname-name path)))))))
        (unless (find (string module)
                      (cdr custom-categ)
                      :test #'string-equal
                      :key #'(lambda (item)
                               (string (car item))))
          (nconc custom-categ (list (list module t t)))
          (reset-env-table-sequence dialog (view-named 'table dialog) custom-categ t))))))

(defmethod env-double-click-hack ((dialog modules-dialog))
  (when (double-click-p)
    (let ((action (if (option-key-p) '(t)
                      (if (command-key-p) '(nil)))))
      (when action
        (setq action (car action))
        (let ((categ (nth (1- (pop-up-menu-default-item (view-named 'category dialog)))
                          *module-categories*)))
          (cond ((string= (car categ) excl-categ-name)
                 (ed-beep))
                (t (dolist (spec (cdr categ))
                     (setf (second spec) action))
                   (refresh-env dialog))))
        t))))

; (State: categories -> table)
(defun modules-dialog ()
  (setq *app-verified* 0
        *app-params-inited* nil)
  (env-dialog 'modules-dialog
              *module-categories*
              "Modules"
              "  Module"
              :position '(:top 77)
              :size #@(386 305)
              :aux-control :add-button
              :doc-wrap t))

; (State: change -> table -> categories)
(defun use-module-defaults (item)
  (dolist (cat *module-categories*)
    (dolist (spec (cdr cat))
      (setf (second spec) (third spec))))
  (refresh-env (view-window item)))

(defun app-prototype (class-name)
  (class-prototype (find-class (symbol-value class-name))))

(defun app-params-path ()
  (or *app-params-path*
      (let ((the-dir (findfolder #$kOnSystemDisk #$kPreferencesFolderType)))
        (unless the-dir
          (message-dialog "Unable to find the Preferences folder.")
          (cancel))
        (setq *app-params-path*
              (merge-pathnames
               (concatenate 'string (get-app-name) ".mcl")
               the-dir)))))

(defmethod env-save ((dialog modules-dialog))
  (catch :cancel
    (env-save-file dialog (app-params-path) modules-file-type '*module-categories*)))

; revert to prefs file values if there is one, else to values current
; at dialog open time
(defmethod env-revert ((dialog modules-dialog))
  (multiple-value-bind (path file-p)
                       (env-file-path dialog)
    (unless (and file-p
                 (with-open-file (stream path
                                         :element-type 'base-character
                                         :if-does-not-exist nil)
                   (load-from-stream stream nil)
                   t))
      (update-categories dialog :revert)))
  (refresh-env dialog))

; OK button action.
; (State: categories -> globals)
(defmethod install-categories ((dialog modules-dialog) categs)
  (update-app-info categs)
  (verify-module-params))

(defun update-app-info (categs)
  (macrolet ((add-token (token place)
               `(unless (member ,token ,place :test #'equalp)
                  (setf ,place (nconc ,place (list ,token)))))
             (remove-token (token place)
               `(setf ,place (delete ,token ,place :test #'equalp))))
    (let* ((first-categ t)
           (app-info *application-info*))
      (setf (app-info-optional-modules app-info) nil
            (app-info-custom-modules   app-info) nil)
      (dolist (categ categs)
        (dolist (spec (cdr categ))
          (let ((token (first spec))
                (value (second spec)))
            (cond (first-categ
                   (if value
                     (add-token    token (app-info-custom-modules app-info))
                     (remove-token token (app-info-custom-modules app-info))))
                  (value (add-token token (app-info-optional-modules app-info)))
                  (t  (remove-token token (app-info-optional-modules app-info))))))
        (setq first-categ nil)))))


;; Build Warnings

(defvar *build-warnings*
  `((:file-not-found . "File \"~A\" not found.")
    (:module-not-found . "Module ~A not found.")
    (:module-not-compiled . "Module ~A is not compiled.")
    (:bad-module . "~S is not a proper module specifier (STRING or SYMBOL).")
    (:no-custom-modules . "No custom modules have been specified for this application.")
    (:bad-optional-modules . "Optional modules specifier ~S is not a list of symbols.")
    (:class-lds . "The LISP-DEVELOPMENT-SYSTEM class should not be used for custom applications.")
    (:class-app . "The APPLICATION class should generally not be used for custom applications; use a subclass instead.")
    (:bad-app-name . "~S is not a proper application name.")
    (:no-creator . "A unique file creator has not been specified; '~A' will be used.")
    (:bad-creator . "The file creator '~A' is not a four-character string or symbol; '~A' will be used.")
    (:bad-size . "Partiton size ~S is not a positive real number.")
    (:small-size . "Partition size ~AK is below the minimum recommended size of ~AK.")
    (:no-resources . "No resource file has been specified for this application.")
    (:resource-not-found . "The resource file ~S was not found.")
    (:bad-toplevel . "~S is not NIL, TOPLEVEL-FUNCTION, or a symbol bound to a function of no arguments.")
    (:bad-error-mode . "~S is not a legal error mode, one of ~S.")
    ))

(defclass build-warn-window (fred-window) ())

(defmethod window-close :after ((w build-warn-window))
  (when (eq w *build-warnings-mode*)
    (setq *build-warnings-mode* nil)))

(defun bwarn (key &rest args)
  (apply #'build-warn *build-warnings-mode* key args))

; create a window
(defmethod build-warn ((mode null) key &rest args)
  (apply #'build-warn
         (setq *build-warnings-mode*
               (make-instance 'build-warn-window
                 :window-title (format nil "\"~A\" Build Warnings" *app-name*)
                 :scratch-p t
                 :word-wrap-p t
                 :view-position '(:top 42)))
         key args))

; output to window
(defmethod build-warn ((w build-warn-window) key &rest args)
  (declare (dynamic-extent args))
  (apply #'format w "~& ~@?~%~%" (cdr (assq key *build-warnings*)) args)
  (force-output w)
  (window-select w)
  (incf *app-verified*))

; add to list
(defmethod build-warn ((mode list) key &rest args)
  (push (list* key args) *build-warnings-mode*))

; Verifies contents of globals.
; Returns true if no warnings occurred.
(defun verify-module-params ()
  (get-app-name)
  (let* ((app-info *application-info*)
         (custom-modules   (app-info-custom-modules   app-info))
         (optional-modules (app-info-optional-modules app-info)))
    (if custom-modules
      (dolist (module custom-modules)
        (typecase module
          (string (unless (find-load-file module)
                    (bwarn :file-not-found module)))
          (symbol (unless (keywordp module)
                    (flet ((find-module-pathname (module)
                             (let ((mod-path (make-pathname :name module :defaults nil)))
                               (dolist (path-cand *module-search-path* nil)
                                 (let ((path (find-load-file (merge-pathnames mod-path path-cand))))
                                   (when path
                                     (return-from find-module-pathname path)))))))
                      (declare (dynamic-extent #'find-module-pathname))
                      (setq *module-file-alist* nil)
                      (let ((path (find-module-pathnames (string module))))
                        (cond ((null path)
                               (bwarn :module-not-found module))
                              ((not (string-equal (pathname-type path) "fasl"))
                               (bwarn :module-not-compiled module)))))))
          (t (bwarn :bad-module module))))
      (bwarn :no-custom-modules))
    (unless (and (listp optional-modules)
                 (every #'symbolp optional-modules))
      (bwarn :bad-optionals optional-modules))))


; Verifies contents of globals.
; Returns true if no warnings occurred.
(defun verify-application-params ()
  (get-app-name)
  (let ((app-info *application-info*))

      (case *app-class-name*
        (lisp-development-system
         (bwarn :class-lds))
        (application
         (bwarn :class-app)))

      (let ((name-len (length *app-name*)))
        (when (or (zerop name-len)
                  (> name-len 31)
                  (find #\: *app-name*))
          (bwarn :bad-app-name *app-name*)))

      (let ((creator (app-info-file-creator app-info)))
        (setf (app-info-file-creator app-info)
              (cond ((null creator)
                     (bwarn :no-creator default-app-creator)
                     default-app-creator)
                    ((typep creator '(or string symbol character))
                     (let* ((string (string creator))
                            (length (length string)))
                       (unless (= length 4)
                         (bwarn :bad-creator creator
                                (setq string (subseq (if (> length 4)
                                                       string
                                                       (%str-cat string "    "))
                                                     0 4))))
                       string))
                     (t (bwarn :bad-creator creator default-app-creator)
                        default-app-creator))))

      (let ((toplevel-fn (app-info-toplevel app-info)))
        (unless (or (null toplevel-fn)
                    (eq toplevel-fn 'toplevel-function)
                    (and (symbolp toplevel-fn)
                         (fboundp toplevel-fn)
                         (zerop (function-args (symbol-function toplevel-fn)))))
          (bwarn :bad-toplevel toplevel-fn)))

      (let ((error-mode (app-info-error-mode app-info)))
        (when (and error-mode (not (assq error-mode error-modes-alist)))
          (bwarn :bad-error-mode error-mode (mapcar #'car error-modes-alist))))

      #+no                              ; do-save-application checks
      (dolist (size (app-info-sizes app-info))
        (cond ((not (and (realp size)
                         (> size 0)))
               (bwarn :bad-size size))
              ((< size min-partition-size)
               (bwarn :small-size size min-partition-size))))

      (let ((rsrc-file (app-info-resource-file app-info)))
        (cond ((or (null rsrc-file) (string= rsrc-file ""))
               (bwarn :no-resources))
              ((not (probe-file rsrc-file))
               (bwarn :resource-not-found rsrc-file))))))

(defun set-app-info (path creator sizes rsrc-file toplevel error-mode init-file)
    (let ((app-info *application-info*))
      (when path
        (setf (app-info-pathname    app-info) (mac-namestring path)))
      (setf (app-info-class-name    app-info) *app-class-name*
            (app-info-file-creator  app-info) creator
            (app-info-sizes         app-info) sizes
            (app-info-resource-file app-info) rsrc-file
            (app-info-toplevel      app-info) toplevel
            (app-info-error-mode    app-info) error-mode
            (app-info-search-path   app-info) *module-search-path*
            (app-info-init-file     app-info) init-file)))

; see FIND-AND-LAUNCH-APPL in sourceserver-command.lisp
(defun build-application (path rsrc-file creator sizes toplevel error-handler init-file)
    (set-app-info path creator sizes rsrc-file toplevel error-handler init-file)
    (unless *app-params-inited*
      ; would be nice to fold these together...
      (update-build-params)
      (update-app-info *module-categories*))
    (verify-application-params)
    (unless (eql *app-verified* 0)
      (catch :cancel
        (when (y-or-n-dialog "Verifying the application parameters produced warnings. Proceed with the build anyway?"
                             :window-type :movable-dialog
                             :position :centered
                             :no-text nil
                             :cancel-text "Yes"
                             :yes-text "Cancel")
          (return-from build-application :cancel))))
    (compile-file *appgen-lisp-path* :output-file *appgen-fasl-path*)
    (when *autolaunch-mcl-appgen*
      (let ((appgen-path (or (probe-file appgen-app-name)
                             (get-creator-path appgen-creator))))
        (if appgen-path
          (launch-application appgen-path)
          (message-dialog (format nil "Couldn't find the MCL-AppGen utility. After installing it, launch it to build the \"~A\" application."
                                  *app-name*))))))

; gots to be a better way...
(defmethod make-load-form ((app-info application-info))
  (let ((form (list 'make-app-info)))
    (dolist (slot (cdr (sd-slots (struct-def app-info))) (nreverse form))
      (push (intern (symbol-name (ssd-name slot))
                    *keyword-package*)
            form)
      (push (list 'quote (uvref app-info (ssd-offset slot)))
            form))))


(defun dump-app-methods (dialog)
  (multiple-value-bind (status res-file sig sizes toplevel error-handler)
                       (get-app-params dialog t)
    (when status
      (set-app-info nil sig sizes res-file toplevel error-handler)
      (let ((*print-case* :downcase))
        (dump-app-info *application-info*)))))

(defun dump-app-info (app-info &optional stream)
  (let ((class-name (app-info-class-name app-info)))
    (unless stream
      (setq stream (make-instance 'fred-window
                     :window-title (format nil "~A ~S methods" class-name *app-name*))))
    (flet ((pprint-method (name value)
             (pprint `(defmethod ,name ((app ,class-name))
                        ,(typecase value
                           ((or null keyword) value)
                           ((or symbol list) `(quote ,value))
                           (t value)))
                     stream)
             (terpri stream)))
      (dolist (pair `((application-name . app-info-name)
                      (application-file-creator . app-info-file-creator)
                      (application-sizes . app-info-sizes)
                      (application-resource-file . app-info-resource-file)
                      (application-toplevel . app-info-toplevel)
                      (application-custom-modules . app-info-custom-modules)
                      (application-optional-modules . app-info-optional-modules)
                      ))
        (pprint-method (car pair) (funcall (cdr pair) app-info)))
      (let ((error-mode (app-info-error-mode app-info)))
        (cond (error-mode (pprint-method 'application-error-mode error-mode))
              (t (format stream "~&~%; application-error-mode was not specified, inherited version will be used~%")))))
    (format stream "~&~%~%#| Other methods you can optionally define:~%")
    (dolist (pair `((application-menubar . nil)
                    (application-about-view . nil)
                    (application-about-dialog . nil)
                    (application-suspend-event-handler . nil)
                    (application-resume-event-handler . nil)
                    (application-eval-enqueue . '(form))))
      (format stream "~&~%(defmethod ~A ((app ~A)~{ ~A~})~%  ...)~%"
              (car pair) class-name (cdr pair)))
    (format stream "~&|#~%")
    (force-output stream)))


; A coupla functions from processes.lisp contribution:

; Given a four-character creator code, finds the most recent application.
; Searches the mounted devices in the order mounted (same as the Finder?)
; until it finds one.
(defun get-creator-path (creator)
  (let ((devs (directory "*:")))
    (dolist (vrefnum (sort (mapcar 'volume-number devs) #'>))
      (rlet ((pb :DTPBRec
                 :ioNamePtr (%null-ptr)
                 :ioVRefnum vrefnum)
             (fsspec :fsspec))
        (when (eql 0 (#_PBDTGetPath pb))
          (setf (rref pb :DTPBRec.ioNamePtr)
                (%inc-ptr fsspec (get-field-offset :fsspec.name))
                (pref pb :DTPBRec.ioIndex) 0
                (pref pb :DTPBRec.ioFileCreator) creator)
          (when (eql 0 (#_PBDTGetAPPLSync pb))
            (setf (pref fsspec :fsspec.vRefnum) vrefnum
                  (pref fsspec :fsspec.parID) (pref pb :DTPBRec.ioAPPLParID))
            (return (%path-from-fsspec fsspec))))))))

(defun launch-application (filename)
  (rlet ((fsspec :FSSpec)
         (pb :launchParamBlockRec
             :launchBlockID #$extendedBlock
             :launchEPBLength #$extendedBlockLen
             :launchControlFlags (+ #$launchContinue #$launchNoFileFlags)
             :launchAppSpec fsspec
             :launchAppParameters (%null-ptr)))
    (with-pstrs ((name (mac-namestring (probe-file filename))))
      (#_FSMakeFSSpec 0 0 name fsspec))
    (let ((err (#_LaunchApplication pb)))
      (cond ((zerop err)
             filename)
            (t (message-dialog 
                (case err               ; Process Manager errors
                  (-600 "No elegible process with specified descriptor.")
                  (-601 "Not enough room to launch application with special requirements.")
                  (-602 "Memory mode is 32-bit, but application not 32-bit clean.")
                  (-603 "Application made module calls in improper order.")
                  (-604 "Hardware configuration not correct for call.")
                  (-605 "Application SIZE not big enough for launch.")
                  (-606 "Application is background-only, and launch flags disallow this.")
                  (-108 "Not enough memory to launch the application (OS Error #-108).")
                  (t (format nil "LaunchApplication error ~D occurred." err)))
                :title "Error")
               nil)))))


;; Build Application Interface

(export 'generate-application)

; returns list of warnings
(defun generate-application (class-name path &key toplevel no-verify compile-modules
                                        ignore-warnings no-launch)
  (setq *module-file-alist* nil)
  (let* ((class (find-class class-name))
         (proto (class-prototype class))
         (*build-warnings-mode* (list :warnings))
         (app-info *application-info*)
         (custom-modules (application-custom-modules proto)))
    (set-app-name (application-name proto))
    (setf *app-class-name* class-name
          (app-info-optional-modules app-info) (application-optional-modules proto)
          (app-info-custom-modules   app-info) custom-modules)
    (when compile-modules
      (dolist (module custom-modules)
        (unless (stringp module)
          (let ((pathname (find-module-pathnames (string module))))
            (when (and pathname (string-equal (pathname-type pathname) "lisp"))
              (compile-file pathname))))))
    (set-app-info path
                  (application-file-creator proto)
                  (application-sizes proto)
                  (application-resource-file proto)
                  toplevel
                  (application-error-mode proto)
                  (application-init-file proto))
    (when (or no-verify
              (progn (verify-module-params)
                     (verify-application-params)
                     (null (cdr *build-warnings-mode*)))
              ignore-warnings)
      (compile-file *appgen-lisp-path* :output-file *appgen-fasl-path*)
      (unless no-launch
        (launch-application (or (probe-file appgen-app-name)
                                (get-creator-path appgen-creator)))))
    (cdr (nreverse *build-warnings-mode*))))

; End of build-application.lisp
