
;;; 04/20/00 akh add ourcallupp2 for carbon/OSX
;;; ----------- 4.3.1b1
;;; 01/29/97 gb  GCC wants a __main function.  Don't ask.
;;; 03/26/96 gb  float->unsigned runtime support for MWC
;;; 03/10/96 gb  set_fpscr; use macros for prolog, epilog
;;; 03/04/96 gb  find_interrupt_context
;;; 12/27/95 gb  count_leading_zeros
;;; 12/13/95 gb  zero_cache_lines fencepost, mwc glue

 

	macro 
	asm_begin &name
	export &name{ds}
	export .&name{pr}

	csect &name{ds}
	dc.l .&name{pr},TOC{tc0}

	csect .&name{pr}
	function .&name{pr}
	endm

	macro
	asm_end &name
	endf
	toc
	tc &name{tc},&name{ds}
	endm

;;; Protect memory via the BSD 'mprotect' system call.
;;; Returns 0 -> success, < 0 -> failure.

       asm_begin mprotect
SYS_mprotect equ 74

	
	li r0,SYS_mprotect
	sc
; Error return.  Could map to a MacOS error, but anything other
; than 0 is catastrophic as far as MCL is concerned.
	blr
;; Normal return.
	blr
        asm_end mprotect

	asm_begin zero_cache_lines



;;; Zero R4 cache lines, starting at address in R3.  Each line is assumed to be
;;; R5 bytes wide.
	cmpwi cr0,r4,0
	mtctr r4
	beqlr
@loop:	dcbz 0,r3
	add r3,r3,r5
@test:	bdnz @loop
	blr
	asm_end zero_cache_lines


	asm_begin current_stack_pointer
	mr r3,sp
	blr
	asm_end current_stack_pointer
	
;;;	__ptr_glue		-	glue for function calls through pointers
;;;
;;;	Call the function whose 2-word TVector address is in R12.
;;; Metrowerks C uses this to do indirect function calls.
;;;
	csect .__ptr_glue{GL}
	export .__ptr_glue{GL}
	lwz r0,0(r12)
	stw RTOC,20(SP)
	mtctr r0
	lwz RTOC,4(r12)
	bctr

	asm_begin count_leading_zeros
	cntlzw r3,r3
	blr
	asm_end count_leading_zeros

	asm_begin find_interrupt_context
	lwz r4,0(sp)		; caller's frame pointer
	lwz r4,0(r4)		; its caller: emulator frame ?
	clrlwi. r5,r4,31	; cr0_eq clear if so
	clrrwi r4,r4,1
	add r3,r4,r3		; add offset
	bnelr			; return if emulator frame
	li r3,0
	blr			; return NULL otherwise
	asm_end find_interrupt_context


	asm_begin set_fpscr
	stw r3,-4(sp)
	lfd fp0,-8(sp)
	mtfsf 0xff,fp0
	blr
	asm_end set_fpscr

	csect __constants{ro}
	dc.l 0x00000000,0x00000000; 0.0
	dc.l 0x41f00000,0x00000000; (expt 2.0 32)
	dc.l 0x41e00000,0x00000000; (expt 2.0 31)

	toc
	tc __constants{tc},__constants{ro}

	asm_begin __cvt_fp2unsigned
	lwz r4,__constants{tc}(RTOC)
	li  r3,0		; r3 = 0	
	lfd  fp0,0(r4)		; fp0 = 0.0
	lfd  fp3,8(r4)		; fp3 = 2**32
	lfd  fp4,16(r4)		; fp4 = 2**31
	fcmpu cr0,fp1,fp0	; cr0 = compare(fp1,0.0)
	fcmpu cr6,fp1,fp3	; cr6 = compare(fp1,2**32)
	bltlr cr0		; return 0x00000000 if input was < 0.0
	addi r3,r3,-1
	bgelr cr6		; return 0xFFFFFFFF if input was >= 2**32
	fcmpu cr7,fp1,fp4	; cr7 = compare(fp1,2**31)
	fmr fp2,fp1
	blt  cr7,@1		; use fp1 if < 2**31
	fsub fp2,fp1,fp4	; subtract 2**31
@1	fctiwz fp2,fp2		; convert float to 8-byte integer
	stfd fp2,-8(SP)		; store 8-byte integer
	lwz  r3,-4(SP)		; load 4-byte integer
	bltlr cr7
	addis r3,r3,-32768	; add 2**31 if input was >= 2**31
	blr
	asm_end __cvt_fp2unsigned

;;;;;;;;;;;;;;;;;----------------------- ourcallupp2

;; a replacement for our usage of CallUniversalProc which will not exist in OSX

kUseNativeISA equ 4


        asm_begin ourcallupp2
;; from constants.s ;; why does this have to be inside asm_begin??
c_frame	record 0
backlink ds.l 1
crsave	ds.l 1
savelr	ds.l 1
unused	ds.l 2
savetoc	ds.l 1
params	ds.l 8
minsiz	equ *
	endr

;; This was busted in that RTOC was not restored after the call - so now we return here to restore it
;; as opposed to doing a "tail call" and counting on the C compiler to insert a restore of RTOC on exit
;; which it won't do because this is in the same library as the caller whereas
;; CallUniversalProc is not (thanks to a friend for explaining all that!).
;; This is modeled after disassembly of pertinent portions of CallUniversalProc.

        mfcr r12
        stw r12,4(SP) ;; save cr    
        lhz r0,0(r3)  ;; r3 has upp 
        cmplwi r0,0xAAFE  ;; cookie 
        bne        bad
        lha        r12,0xA(r3)  ;; is cookie, get routinecount
        cmplwi     cr1,r12,0    ;; should be 0
        bne        cr1,bad
        addi       r11,r3,0xC   ;;rouutinecount is 0, put upp + c in r11
        lwz        r4,0(r11)    ;; here if routinecount is 0 r11 has addr of routinerecord , get procinfo to r4 - so the incoming  procinfo isn't used.
                                ;; One did wonder what would happen if incoming procinfo differed from that in the UPP.
        lhz        r12,6(r11)   ;; routineflags - always 4  - native
        cmpwi cr1,r12,kUseNativeISA ; check it
        bne cr1,bad
        ;; grovel around with r4. I suppose one could be more symbolicwise here but the fact is 13 args is all you get        
        CMPWI R4,0
        BEQ DOIT 
        extrwi.    r0,r4,2,0 
     bne        shuf13
     extrwi. r0,r4,2,2
     bne shuf12
     extrwi. r0,r4,2,4
     bne shuf11
     extrwi. r0,r4,2,6
     bne shuf10
     extrwi. r0,r4,2,8
     bne shuf9
     extrwi. r0,r4,2,10
     bne shuf8
     extrwi. r0,r4,2,12
     bne shuf7
     extrwi. r0,r4,2,14
     bne shuf6
     extrwi. r0,r4,2,16
     bne shuf5
     extrwi. r0,r4,2,18
     bne shuf4
     extrwi. r0,r4,2,20
     bne shuf3
     extrwi. r0,r4,2,22
     bne shuf2
     extrwi. r0,r4,2,24
     bne shuf1
     b doit

shuf8: mr         r3,r5  ;; shuffle 8 args 
       mr         r4,r6
       mr         r5,r7 
       mr         r6,r8 
       mr         r7,r9
       mr         r8,r10 
       lwz        r9,0x0038(SP) 
       lwz        r10,0x003C(SP)
       b doit
shuf7: mr         r3,r5  ;; shuffle 7 args 
       mr         r4,r6
       mr         r5,r7 
       mr         r6,r8 
       mr         r7,r9
       mr         r8,r10 
       lwz        r9,0x0038(SP) 
       b doit
shuf6:      mr         r3,r5  ;; shuffle 6  args 
      mr         r4,r6 
      mr         r5,r7 
      mr         r6,r8 
      mr         r7,r9 
      mr         r8,r10      
      b doit 
shuf5: mr         r3,r5  ;; shuffle 5 args 
      mr         r4,r6 
      mr         r5,r7 
      mr         r6,r8 
      mr         r7,r9 
      b doit
shuf4:
    mr         r3,r5  ;; shuffle 4 args 
      mr         r4,r6 
      mr         r5,r7 
      mr         r6,r8 
     b doit
shuf3:
    mr         r3,r5  ;; shuffle 3 args 
      mr         r4,r6 
      mr         r5,r7 
     b doit
shuf2: mr         r4,r6      
shuf1: mr r3,r5
doit: lwz        r12,8(r11)   ;; here after args shuffled ! r11 has addr of routinerecord 
     lwz        r0,4(SP)      ;; saved cr? 
     mtcrf      0xFF,r0
     stw r0,c_frame.crsave(sp)    ;; save cr in callers frame    
     mflr r0
     stw r0,c_frame.savelr(sp)    ;; save lr in callers frame
     stw RTOC,c_frame.savetoc(SP) ;; save rtoc in callers frame vs ours??
     stwu SP,-((c_frame.minsiz+15)&~15)(SP)  ;; make a new stack frame of size c_frame.minsiz so callee can stomp on it - tis bizarre   
     ;stw RTOC,c_frame.savetoc(SP) ;; save rtoc in our frame - should that be in callers frame too?? maybe/probably
     
     lwz        r0,0(r12)    ;; r12 has procdescriptor - aka procptr, aka transfervector- put 1st thing in r0 
     lwz        RTOC,4(r12)  ;; put next thing in TOC   
     mtctr      r0                  
     bctrl
     
     ;lwz RTOC,c_frame.savetoc(SP) ;; restore rtoc from our frame??
     lwz sp,0(sp)                 ;; pop our frame
     lwz RTOC,c_frame.savetoc(SP) ;; restore rtoc from callers frame vs above from our frame??
     lwz r0,c_frame.crsave(sp)    ;; restore cr from callers frame, who cares about preserving cr?
     mtcr r0
     lwz r0,c_frame.savelr(sp)    ;; retrieve saved lr from callers frame and return to it
     mtlr r0    
     blr

;; if the darn thing ever works it's easy enuf to fill in the shufXX things
;; but we actually only use 0 or 6 args
bad:
shuf13:
shuf12:
shuf11:
shuf10:
shuf9:
        li r3,0  ;; enter debugger
	tw 28,sp,sp		; 28 = lt|gt|eq (assembler bug for the latter)
	blr
 
  
     

        asm_end ourcallupp2

       
;; Under OSX Carbon, the Exception Manager calls the user-defined exception handler
;; with a badly misaligned stack.  Let it call this function, which calls the real
;; exception handler on an aligned stack.
	asm_begin aligned_exception_handler
	import .PMCL_exception_handler
	mflr r0
	la r4,-64(sp)
	clrrwi r4,r4,4
	stw r0,8(sp)
	sub r4,r4,sp
	stwux sp,sp,r4
	bl .PMCL_exception_handler
	nop
	lwz sp,0(sp)
	lwz r0,8(sp)
	mtlr r0
	blr
	asm_end aligned_exception_handler

;; GCC wants a __main function.  Don't ask.

	asm_begin __main
	blr
	asm_end __main

	end

 





