#include <fcntl.h>
#include <ioctl.h>

/* These should always remain 32 bit quantities */

typedef int int32;
typedef long long32;
typedef unsigned unsigned32;


typedef struct MPWIOVector {
  OSType type;
  UniversalProcPtr faccess;
  UniversalProcPtr close;
  UniversalProcPtr read;
  UniversalProcPtr write;
  UniversalProcPtr ioctl;
} MPWIOVector;

#pragma options align=mac68k
typedef struct MPWIOEntry {
  short  flags; /* See open() mode in FCntl. */
  OSErr  error;
  MPWIOVector * funcs;
  int32  userData;
  unsigned32 length;
  unsigned char *buffer;
} MPWIOEntry; 
#pragma options align=reset


typedef int32 (*MPWAccessFunction)(char * name, unsigned int cmd, long *arg);
typedef int32 (*MPWIOFunction)(MPWIOEntry * entry);
typedef int32 (*MPWIOCtlFunction)(MPWIOEntry * entry, unsigned int cmd, long *arg);


struct MPWSeekArg {
  int32 whence;
  long32 offset;
};


extern MPWIOEntry *_getIOPort(int32 *);
extern int32  _addDevHandler(int32, 
			     OSType,
			     MPWAccessFunction,
			     MPWIOFunction,
			     MPWIOFunction,
			     MPWIOFunction,
			     MPWIOCtlFunction);

